# Chapter 3
library(lavaan)

# Read the data:

Data <- read.csv("pisa_domrep_MPLUS_final.csv", header = FALSE)
names(Data) <- c("schoolid", "vid", "dl1", "dl2", 
                 "isc", "ils", "hwc")
# missing data
Data[ Data == -999 ] <- NA


# Figure 3.3

model <- '
  level: 1
    funw =~ vid + dl1 + dl2
    schw =~ isc + ils + hwc

  level: 2
    funb =~ vid + dl1 + dl2
    schb =~ isc + ils + hwc
'

fit <- sem(model, data = Data, cluster = "schoolid", estimator = "MLR")
summary(fit, fit.measures = TRUE, standardized = TRUE)


# Figure 3.4
model <- '
  level: 1
    funw =~ vid + dl1 + dl2
    schw =~ isc + ils + hwc

  level: 2
    dig =~ vid + dl1 + dl2 + isc + ils + hwc
'

fit <- sem(model, data = Data, cluster = "schoolid", estimator = "MLR")
summary(fit, fit.measures = TRUE, standardized = TRUE)


